﻿namespace U2UConsult.Win8.PrintItemsControl.Views
{
    using U2UConsult.Win8.Printing;
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Controls;
    using Windows.UI.Xaml.Navigation;

    public sealed partial class MainPage : Page
    {
        private PrintServiceProvider printServiceProvider = new PrintServiceProvider();

        public MainPage()
        {
            this.InitializeComponent();
            this.Loaded += this.MainPage_Loaded;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // Registering for printing here, will leave the list blank.
            // That's weird.

            // this.printServiceProvider.RegisterForPrinting(this, typeof(PrintReport), this.DataContext);
        }

        // Not called in this single page app, just for your info.
        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);

            this.printServiceProvider.UnregisterForPrinting();
        }

        // This seems to be the safe place to register for printing.
        // All underlying controls are there, and bound to their data context.
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.printServiceProvider.RegisterForPrinting(this, typeof(PrintReport), this.DataContext);
        }

        private void PrintButton_Clicked(object sender, RoutedEventArgs e)
        {
            this.printServiceProvider.Print();
        }
    }
}